package com.vendor.burn.model;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.model.cmdline.CmdType;
import com.vendor.burn.model.config.BurnConfig;
import com.vendor.burn.model.define.IConfig;
import com.vendor.burn.preferences.FastbootPreferences;
import com.vendor.burn.serial.workers.SerialHelper;
import com.vendor.burn.utilitily.IPUtils;
import com.vendor.burn.utilitily.ToolUtils;
import com.vendor.burn.views.CmdMain;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Arrays;
import java.util.List;

public class LocalConfig implements IConfig {
  private String comPort = "COM1";
  
  private String serverIp;
  
  private boolean isRemoteTftpServer;
  
  private String remoteTftpServerDir;
  
  private String loaderPath = "";
  
  private boolean isDefaultAllinoneLoader;
  
  public LocalConfig() {
    if (ToolUtils.isCmdLine()) {
      localCmdlineConfig();
    } else {
      localComposite();
    } 
  }
  
  private void localComposite() {
    String serial = FastbootPreferences.CONFIG.getSerial();
    if (serial != null) {
      List<String> listSerialPorts = SerialHelper.getSerialPorts();
      if (listSerialPorts.contains(serial)) {
        this.comPort = serial;
      } else if (!listSerialPorts.isEmpty()) {
        this.comPort = listSerialPorts.get(0);
      } 
    } 
    String serverIP = FastbootPreferences.CONFIG.getServerIP();
    String[] serverIps = IPUtils.getServerIps();
    if (IPUtils.isValidIP(serverIP)) {
      if (Arrays.<String>asList(serverIps).contains(serverIP)) {
        this.serverIp = serverIP;
      } else if (serverIps.length > 0) {
        this.serverIp = serverIps[0];
      } 
    } else {
      try {
        this.serverIp = InetAddress.getLocalHost().getHostAddress();
      } catch (UnknownHostException e) {
        if (serverIps.length > 0)
          this.serverIp = serverIps[0]; 
      } 
    } 
  }
  
  private void localCmdlineConfig() {
    String serial = "";
    String serverIP = "";
    com.vendor.burn.model.LocalConfig localConfig = BurnConfig.getLocalConfig();
    if (localConfig != null) {
      serial = localConfig.getComPort();
      serverIP = localConfig.getServerIp();
    } 
    CmdType curCmdType = CmdMain.getCurCmdType();
    if (curCmdType != null && curCmdType == CmdType.burn) {
      if (serial != null) {
        List<String> listSerialPorts = SerialHelper.getSerialPorts();
        if (listSerialPorts.contains(serial)) {
          this.comPort = serial;
        } else if (!listSerialPorts.isEmpty()) {
          this.comPort = listSerialPorts.get(0);
        } 
      } 
      String[] serverIps = IPUtils.getServerIps();
      if (IPUtils.isValidIP(serverIP)) {
        if (Arrays.<String>asList(serverIps).contains(serverIP)) {
          this.serverIp = serverIP;
        } else if (serverIps.length > 0) {
          this.serverIp = serverIps[0];
        } 
      } else {
        try {
          this.serverIp = InetAddress.getLocalHost().getHostAddress();
        } catch (UnknownHostException e) {
          if (serverIps.length > 0)
            this.serverIp = serverIps[0]; 
        } 
      } 
    } 
  }
  
  public boolean isRemoteTftpServer() {
    return this.isRemoteTftpServer;
  }
  
  public void setRemoteTftpServer(boolean isRemoteTftpServer) {
    this.isRemoteTftpServer = isRemoteTftpServer;
  }
  
  public String getRemoteTftpServerDir() {
    return this.remoteTftpServerDir;
  }
  
  public void setRemoteTftpServerDir(String remoteTftpServerDir) {
    this.remoteTftpServerDir = remoteTftpServerDir;
  }
  
  public String getServerIp() {
    return this.serverIp;
  }
  
  public void setServerIp(String serverIp) {
    this.serverIp = serverIp;
  }
  
  public String getComPort() {
    return this.comPort;
  }
  
  public void setComPort(String comPort) {
    this.comPort = comPort;
  }
  
  public String getLoaderPath() {
    return this.loaderPath;
  }
  
  public void setLoaderPath(String loaderPath) {
    this.loaderPath = loaderPath;
  }
  
  public boolean isDefaultAllinoneLoader() {
    return this.isDefaultAllinoneLoader;
  }
  
  public void setDefaultAllinoneLoader(boolean isDefaultAllinoneLoader) {
    this.isDefaultAllinoneLoader = isDefaultAllinoneLoader;
  }
}
